// scroll_text_changer.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>

unsigned char firmware_installer[0x80000];

#define scroll_text firmware_installer[scroll_loc+(j++)]

int insert_scroller(char *nds_file, char *scroller_text, int erase_scroller)
{

	int i,j,k;
	int scroll_loc;
	FILE *f;

	char scroll_text_start[] = {"***SCROLLER TEXT START***"};

	j=firmware_installer[0x2C]+(firmware_installer[0x2D]<<8);
	j+=(firmware_installer[0x2E]<<16)+(firmware_installer[0x2F]<<24);
	j+=0x200;

	for(i=0x200;i<j;i++)
	{
		for(k=0;k<25;k++)
		{
			if(scroll_text_start[k] != firmware_installer[i+k])
				break;
		}
		if(k==25)
			break;
	}
	if(i==j)
	{
		printf("Error: SCROLL_TEXT was not defined in\n");
		printf("%s. Uncomment #define SCROLL_TEXT 1\n",nds_file);
		printf("in options.h, rebuild firmware and installer, and\n");
		printf("try again\n");
		return 1;
	}
	scroll_loc = i+25;

	f=fopen(scroller_text,"r");
	if(f==NULL)
	{
		if(erase_scroller)
		{
			for(j=0;j<2048;)
				scroll_text = 0;
			return 0;
		}
		printf("Error: %s not found.\n",scroller_text);
		printf("Create file %s, put whatever scrolltext\n",scroller_text);
		printf("you want, and try again\n");
		return 1;
	}
	j=0;
	while(((i=fgetc(f))!=EOF)&&(j<2047))
	{
		if((i==13)||(i==10))
			continue;
		if(i=='\\')
		{
			i=fgetc(f);
			if(i==EOF)
				break;
			if(i=='\\')
			{
				scroll_text = i;
				continue;
			}
			if(i=='n')
			{
				for(k=0;k<32;k++)
					scroll_text = ' ';
				continue;
			}
			if(i=='/')
			{
				scroll_text = '/';
				continue;
			}

			printf("Warning: Unrecognized Control code \\%c\n",i);
			scroll_text = '\\';
			scroll_text = i;
			continue;

		}

		if(i=='/')
		{
			i=fgetc(f);
			if(i==EOF)
				break;
			if(i=='/')
			{
				while(((i=fgetc(f))!=EOF))
				{
					if((i==10)||(i==13))
						break;
				}
				if(i==EOF)
					break;
				continue;

			}
			scroll_text = '/';
			scroll_text = i;
			continue;
		}

		scroll_text = i;
	}
	fclose(f);
	scroll_text = 0;

	return 0;
}

int open_nds(char *nds_file, char *scroller_text, int erase_scroller=1)
{
	FILE *f;
	int filesize;

	printf("Opening %s for Scroller insertion\n",nds_file);
	f=fopen(nds_file,"rb+");
	if(f==NULL)
	{
		printf("Error: Could not find %s\n",nds_file);
		printf("Please build the firmware, and installer\n");
		printf("try again\n");
		return 1;
	}
	fseek(f,0,SEEK_END);
	if(ftell(f)>0x80000)
	{
		printf("Error: %s too large\n",nds_file);
		fclose(f);
		return 1;
	}
	fseek(f,0,SEEK_SET);
	printf("%s opened Successfully, Inserting scroller %s\n",nds_file,scroller_text);
	filesize=fread(firmware_installer,1,0x80000,f);
	if(insert_scroller(nds_file,scroller_text,erase_scroller))
	{
		fclose(f);
		return 1;
	}
	fseek(f,0,SEEK_SET);
	fwrite(firmware_installer,1,filesize,f);
	fclose(f);
	printf("Scroller %s Inserted successfully\n\n",scroller_text);
	return 0;
}

int main(int argc, char* argv[])
{

	int result;

	char scroller_text[] = "scroller.txt";

	printf("Nintendo DS Firmware Nitro Scroll Text Changer\n");
	printf("Copyright 2005, CaitSith2\n\n");
	
	if(argc<3)
	{
		open_nds("installer.nds",scroller_text);
		open_nds("Scroller only\\installer.nds",scroller_text);
		open_nds("Scroller, MKDS\\installer.nds",scroller_text);

		open_nds("installer.ds.gba",scroller_text);
		open_nds("Scroller only\\installer.ds.gba",scroller_text);
		open_nds("Scroller, MKDS\\installer.ds.gba",scroller_text);

		open_nds("firmware.nds",scroller_text);
		open_nds("Scroller only\\firmware.nds",scroller_text);
		open_nds("Scroller, MKDS\\firmware.nds",scroller_text);

		open_nds("firmware.ds.gba",scroller_text);
		open_nds("Scroller only\\firmware.ds.gba",scroller_text);
		open_nds("Scroller, MKDS\\firmware.ds.gba",scroller_text);
		
	}
	else
	{
		result=(open_nds(argv[1],argv[2],0));
		if(result)
			return result;
	}




	return 0;
}
